Option Explicit On

Public Class frmIPStats

    Private _thisHost As frmIPSpy = Nothing

    Public Sub New(ByVal thisHost As frmIPSpy)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        _thisHost = thisHost

    End Sub

    Private Sub frmIPStats_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        With lvClient

            .Items.Add("Status", "Status", 0).SubItems.Add("")
            .Items.Add("Connected", "Connected To", 0).SubItems.Add("")
            .Items.Add("BytesRecv", "Bytes Received", 0).SubItems.Add("")
            .Items.Add("BytesSent", "Bytes Sent", 0).SubItems.Add("")
            .Items.Add("PacketsRecv", "Packets Received", 0).SubItems.Add("")
            .Items.Add("PacketsSent", "Packets Sent", 0).SubItems.Add("")

        End With

        With lvServer

            .Items.Add("Status", "Status", 0).SubItems.Add("")
            .Items.Add("Connected", "Connection From", 0).SubItems.Add("")
            .Items.Add("BytesRecv", "Bytes Received", 0).SubItems.Add("")
            .Items.Add("BytesSent", "Bytes Sent", 0).SubItems.Add("")
            .Items.Add("PacketsRecv", "Packets Received", 0).SubItems.Add("")
            .Items.Add("PacketsSent", "Packets Sent", 0).SubItems.Add("")

        End With

        timerUpdate_Tick(Nothing, Nothing)

    End Sub

    Private Sub mnuClientCopy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuClientCopy.Click

        Try

            Dim copyData As String = ""
            For i As Integer = 0 To lvClient.Items.Count - 1

                copyData += lvClient.Items(i).Text + vbTab + lvClient.Items(i).SubItems(1).Text + vbCrLf

            Next

            Clipboard.SetText(copyData, TextDataFormat.Text)

        Catch
        End Try

    End Sub

    Private Sub mnuServerCopy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuServerCopy.Click

        Try

            Dim copyData As String = ""
            For i As Integer = 0 To lvServer.Items.Count - 1

                copyData += lvServer.Items(i).Text + vbTab + lvServer.Items(i).SubItems(1).Text + vbCrLf

            Next

            Clipboard.SetText(copyData, TextDataFormat.Text)

        Catch
        End Try

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click

        Me.Close()

    End Sub

    Private Sub timerUpdate_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timerUpdate.Tick

        With lvClient

            .Items("Status").SubItems(1).Text = IIf(_thisHost.btnClientCmd.Tag, "Connected", "Disconnected")

            If .Items("Status").SubItems(1).Text = "Connected" Then

                .Items("Connected").SubItems(1).Text = _thisHost.ClientDisplayText
                .Items("BytesRecv").SubItems(1).Text = _thisHost.ClientBytesRecvCount.ToString("###,##0")
                .Items("BytesSent").SubItems(1).Text = _thisHost.ClientBytesSentCount.ToString("###,##0")
                .Items("PacketsRecv").SubItems(1).Text = _thisHost.ClientPacketsRecvCount.ToString("###,##0")
                .Items("PacketsSent").SubItems(1).Text = _thisHost.ClientPacketsSentCount.ToString("###,##0")

            Else

                .Items("Connected").SubItems(1).Text = ""
                .Items("BytesRecv").SubItems(1).Text = ""
                .Items("BytesSent").SubItems(1).Text = ""
                .Items("PacketsRecv").SubItems(1).Text = ""
                .Items("PacketsSent").SubItems(1).Text = ""

            End If

        End With

        With lvServer

            .Items("Status").SubItems(1).Text = IIf(_thisHost.btnServerCmd.Tag, _
                IIf(_thisHost.ServerDisplayText <> "", "Connected", _
                IIf(_thisHost.radTCP.Checked, "Listening on", "Binded to") + " port " + CStr(Val(_thisHost.txtServerPort.Text))), "Disconnected")

            If .Items("Status").SubItems(1).Text = "Connected" Or _
                (Not .Items("Status").SubItems(1).Text = "Disconnected" And _
                _thisHost.radUDP.Checked) Then

                .Items("Connected").SubItems(1).Text = _thisHost.ServerDisplayText
                .Items("BytesRecv").SubItems(1).Text = _thisHost.ServerBytesRecvCount.ToString("###,##0")
                .Items("BytesSent").SubItems(1).Text = _thisHost.ServerBytesSentCount.ToString("###,##0")
                .Items("PacketsRecv").SubItems(1).Text = _thisHost.ServerPacketsRecvCount.ToString("###,##0")
                .Items("PacketsSent").SubItems(1).Text = _thisHost.ServerPacketsSentCount.ToString("###,##0")

            Else

                .Items("Connected").SubItems(1).Text = ""
                .Items("BytesRecv").SubItems(1).Text = ""
                .Items("BytesSent").SubItems(1).Text = ""
                .Items("PacketsRecv").SubItems(1).Text = ""
                .Items("PacketsSent").SubItems(1).Text = ""

            End If

        End With

    End Sub

End Class